---
layout: markdown_page
title: "Category Strategy - Geo-replication"
description: "Using Geo replications reduces the time it needs to fetch and clone repositories, which increases developer productivity. Learn more here!"
canonical_path: "/direction/geo/geo_replication/"
---

- TOC
{:toc}

## 🌏 Geo-replication

**Last updated**: 2021-09-22

### Introduction and how you can help

- [Overall Strategy](/direction/geo/)
- [Roadmap for Geo Replication](https://gitlab.com/groups/gitlab-org/-/roadmap?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Ageo&label_name[]=geo%3A%3Aactive)
- [Maturity: <%= data.categories["geo_replication"].maturity.capitalize %>](/direction/maturity/)
- [Documentation](https://docs.gitlab.com/ee/administration/geo/index.html)
- [Complete Maturity epic](https://gitlab.com/groups/gitlab-org/-/epics/1508)
- [All Epics](https://gitlab.com/groups/gitlab-org/-/epics?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Ageo)

The Geo-replication category helps distributed developer teams be more
productive. With a single GitLab instance working with large repositories can
take a long time for developers located in different geographies.
Geo-replication provides an easily configurable, read-only mirror (we call it a
Geo site) of a GitLab installation that is complete, accurate, verifiable and
efficient. This is valuable because using Geo reduces the time it takes to
fetch and clone repositories, which increases developer productivity.

Please reach out to Nick Nguyen, Acting Product Manager for the Geo group
([Email](mailto:nnguyen@gitlab.com)) if you'd like to provide feedback or ask
any questions related to this product category.

This strategy is a work in progress, and everyone can contribute. Please comment and contribute in the linked
[issues](https://gitlab.com/groups/gitlab-org/-/issues?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Ageo) and [epics](https://gitlab.com/groups/gitlab-org/-/epics?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Ageo) on this page. Sharing your feedback directly on GitLab.com is the best way to contribute to our strategy and vision.

### Overview

Geo-replication requires a significant investment to be
configured by systems administrators but allows users in different locations to
accelerate `git` read operations. Write requests are transparently proxied to the
primary site. Geo replicates around [83% of the data generated by GitLab](https://docs.gitlab.com/ee/administration/geo/replication/datatypes.html#limitations-on-replicationverification) and
a number of data types [can be disabled if required](https://docs.gitlab.com/ee/administration/geo/replication/datatypes.html#replicated-data-types-behind-a-feature-flag).

### Where we are headed

Our goal for Geo-replication is to offer the same experience to users,
regardless of their location. In the future, we want our users to be able to
configure Geo within minutes - not hours. We envision Geo-replication to be
fully transparent to users. This means that a developer should not need to
actively decide to use Geo, or select the right Geo site - GitLab should be able
to determine what Geo site should be used to provide the best user experience.
For systems administrators, it should be simple to add, configure and remove new
sites.

- Pulls and clones of git repositories should be fast everywhere - especially for large repositories.
- Users should not be required to configure geo-replication manually - we should detect the best Geo site automatically.
- Geo-replication should be easy to set-up and configure - new Geo site should be added with minimal effort.
- Geo-replication should be fully transparent for users - ideally a user of GitLab does not even notice that they are using a Geo site.
- Geo-replication should allow fine-grained control over what is replicated where - not every project and repository needs to be shared.
- All data types generated by GitLab should be replicated and verified.
- It should be easy to use Geo sites for CI/CD to reduce load on a primary site.

### Target audience and experience

#### [Sidney (Systems Administrator)](https://about.gitlab.com/handbook/marketing/strategic-marketing/roles-personas/#sidney-systems-administrator)

- 🙂 **Minimal** - Sidney is able to configure the Geo-replication setup manually, most commonly used data types are replicated.
- 😊 **Viable** - Sidney is able to configure Geo-replication in a mostly automated fashion. Various Geo-replication tasks (status reports, maintenance etc.) can be performed using the GitLab UI. All customer relevant data types are replicated.
- 😁 **Complete** - Sidney can setup Geo in an automated and fast way (minutes, not hours). A dashboard provides an overview for all relevant Geo tasks.
- 😍 **Lovable** - Sidney can setup Geo in an automated and fast way and everything is configurable from the UI, all sites appear writable.

#### [Sasha (Software Developer)](https://about.gitlab.com/handbook/marketing/strategic-marketing/roles-personas/#sasha-software-developer)

- 🙂 **Minimal** - Sasha has to configure Git manually to use Geo. No automatic proxying of request to the primary. WebUI on secondary is not available.
- 😊 **Viable** - Sasha has to configure Git manually but automatic proxying to the primary is possible. WebUI is read-only.
- 😁 **Complete** - Sasha only requires a single URL for all operations - the correct Geo site is used automatically. Sasha can point CI/CD jobs to a Geo secondary site to reduce load on the primary.
- 😍 **Lovable** - Sasha can push and pull directly to a Geo site. Everything is read and writable, including the WebUI. The user experience is the same independent of location.

For more information on how we use personas and roles at GitLab, please [click
here](https://about.gitlab.com/handbook/marketing/strategic-marketing/roles-personas/).

### What's next & why

#### Geo automatically chooses the best GitLab site

Using a Geo site to overcome UX issues (e.g. latency)  requires additional configuration for software developers, which is cumbersome. Using the secondary Web interface is a worse user experience than using the primary. A software developer needs to switch between a primary and secondary frequently, which can be highly confusing and frustrating.

We plan to [automatically choose the best Geo site](https://gitlab.com/groups/gitlab-org/-/epics/1466). This means that Geo will forward any requests from a secondary to a primary *unless* the user experience can be significantly improved by using the secondary. This will likely result in the deprecation of the read-only web interface because requests will be proxied from a secondary to a primary.

We are [investigating a proof of concept](https://gitlab.com/gitlab-org/gitlab/-/issues/207168) that would allow Geo to proxy any requests to the primary site unless a secondary site can significantly improve the user experience.

#### Geo should be easy to setup

Setting up Geo is highly manual and cumbersome, especially in high-availability
configurations. Simplifying the installation and configuration of Geo for single
and multi-node sites will remove a pain point for administrators and help drive adoption.

#### Ability to disable Geo replication by data type in the UI

To save bandwidth and resources, an administrator may want to selectively enable and disable
Geo replication for certain types of data. Currently, this is not possible unless a data type
is released behind a feature flag, and this is not the case for all data types. We want to
provide administrators an easy way to [enable or disable replication by data type in the Geo Administrator UI](https://gitlab.com/groups/gitlab-org/-/epics/6388).


### In a year

#### Publish a Geo metrics dashboard

It is currently possible for systems administrators to get a basic overview of the Geo status using the Geo Web UI.
However, administrators would like easier access to more in-depth Geo metrics such as [the time it takes to mirror a commit](https://gitlab.com/gitlab-org/gitlab/-/issues/197147). We want to define and implement key metrics that allow administrators to better monitor their Geo
installations and [publish the metrics to a preconfigured Grafana dashboard](https://gitlab.com/groups/gitlab-org/-/epics/1530).

#### Improved Geo support for CI/CD

Some customers would like to use their [Geo sites for CI/CD](https://gitlab.com/groups/gitlab-org/-/epics/1527). For example, a customer located in Europe and offices in Australia may want certain pipelines to clone from the Australia secondary.
Another possible use-case for Geo could be to work as a "mirror" to lower the pressure on the primary site for the automated builds.
At the moment, using a Geo secondary for CI/CD is not well-documented, may require complex workarounds, and does not guarantee that
repositories and other data are up-to-date. 

#### Geo supports an advanced caching mode

For Geo-replication only a subset of data may need to be replicated but Geo sites require spinning up the entire GitLab stack, less may be sufficient. Additionally, systems administrators can select a subset via selective sync, but they may be wrong.

We are investigating an [advanced caching mode](https://gitlab.com/groups/gitlab-org/-/epics/2610) with the following properties:

- A Geo site that dynamically determines which data needs to be kept close to the remote location
- Minimal hardware requirements
- Fully hidden behind geo-location aware URL

### What is not planned right now

We are currently not planning on moving away from PostgreSQL as a backend database
in favour of e.g CockroachDB or Google Spanner. This has implications for
writable Geo site Geo, but for now we will continue to support PostgreSQL.

#### Writable Geo sites

Geo secondary sites are read-only. Customer feedback has indicated a desire for additional
[Active active git replication](https://gitlab.com/gitlab-org/gitlab/-/issues/1381). With the availability of [Gitaly Cluster](https://docs.gitlab.com/ee/administration/gitaly/praefect.html) we may start investigating writable Geo sites at some point in FY23.

### Maturity plan

This category is currently at the `<%= data.categories["geo_replication"].maturity.capitalize %>` maturity level, and our next maturity
target is `Complete` (see our [definitions of maturity
levels](/direction/maturity/#legend).

You can track the work that will move the category to `Complete` in
[this epic](https://gitlab.com/groups/gitlab-org/-/epics/1508).

### Metrics

- Performance indicator is [number of unique users utilizing a Geo secondary](https://about.gitlab.com/handbook/product/enablement-section-performance-indicators/#enablementgeo---paid-gmau---number-of-unique-users-utilizing-a-geo-secondary)
- We track the [total number of Geo sites and potential users](https://app.periscopedata.com/app/gitlab/500159/Enablement::Geo-Metrics?widget=9939914&udv=0)
- We track the [distribution of Geo site number](https://app.periscopedata.com/app/gitlab/500159/Enablement::Geo-Metrics?widget=6471733&udv=0)

### Competitive landscape

The top competitors for Geo-replication are

- [GitHub Enterprise geo-replication](https://help.github.com/en/enterprise/2.17/admin/installation/about-geo-replication)
- [Azure DevOps](https://azure.microsoft.com/en-in/services/devops/)
- [Bitbucket Smart Mirroring](https://confluence.atlassian.com/bitbucket/work-with-bitbucket-smart-mirroring-838427532.html)

#### Feature overview

| Feature                     | GitHub | AzureDevOps | Bitbucket Smart Mirroring | GitLab |
|-----------------------------|--------|-------------|---------------------------|--------|
| Mirror repositories         | ✅      | ✅           | ✅                         | ✅      |
| Active-active replication   | ✅      | N/A         | ❌                         | ❌      |
| Selective sync              | N/A    | N/A         | ✅                         | ⚠️      |
| UI configuration            | ❌      | ✅           | N/A                       | ⚠️      |
| Kubernetes support          | ❌      | ❌           | ❌                         | ⚠️      |
| Mirror docker registries    | ❌      | N/A         | ❌                         | ✅      |
| LFS and file upload support | ✅      | N/A         | ✅                         | ✅      |
| Automatic DNS               | ✅      | ✅           | ❌                         | ⚠️      |
| GUI Dashboard               | ✅      | ✅           | N/A                       | ✅      |
| Request proxying            | ✅      | N/A         | N/A                       | ⚠️      |

 ✅ Fully available
 ⚠️ Partially available
 ❌ Not available
 N/A No information available

### Top customer success/sales issue(s)

- [GitLab CI should be able to use specific Geo secondary to clone from](https://gitlab.com/gitlab-org/gitlab/-/issues/3294)
- [Active active git replication](https://gitlab.com/gitlab-org/gitlab/-/issues/1381)

### Top user issues

- [Category issues listed by popularity](https://gitlab.com/groups/gitlab-org/-/issues?scope=all&state=opened&label_name[]=group%3A%3Ageo&label_name[]=Category%3AGeo%20Replication)

### Top internal customer issues/epics

- [Geo: Create a Geo metrics dashboard](https://gitlab.com/groups/gitlab-org/-/epics/1530)

### Top strategy item(s)

- [Simplify Geo's installation](https://gitlab.com/groups/gitlab-org/-/epics/1465)
- [Secondary mimicry](https://gitlab.com/gitlab-org/gitlab/-/issues/207168)
- [Geo: Use Geo sites for CI/CD](https://gitlab.com/groups/gitlab-org/-/epics/1527)
